﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace AppointmentsAndMeetings
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("D3C6F131-1B89-4386-BB3C-4B35A841A10A"), ProgId("AppointmentsAndMeetings.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton adxCreateAppointmentRibbonButton;
        private ImageList imlIcons32;
        private AddinExpress.OL.ADXOlFormsManager adxOlFormsManager1;
        private AddinExpress.OL.ADXOlFormsCollectionItem adxOlFormsCollectionItem1;
        private ADXRibbonButton adxAppointmentWithReminderRibbonButton;
        private ADXRibbonButton adxRecurringAppointmentRibbonButton;
        private ADXRibbonGroup adxMeetingRibbonGroup;
        private ADXRibbonButton adxCreateMeetingRibbonButton;
        private ADXRibbonButton adxCheckNamesDialogRibbonButton;
        private ADXRibbonButton adxAcceptMeetingRibbonButton;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxCreateAppointmentRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.imlIcons32 = new System.Windows.Forms.ImageList(this.components);
            this.adxOlFormsManager1 = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.adxOlFormsCollectionItem1 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            this.adxAppointmentWithReminderRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRecurringAppointmentRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxMeetingRibbonGroup = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxCreateMeetingRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxCheckNamesDialogRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxAcceptMeetingRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "Appointments && Meetings";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Controls.Add(this.adxMeetingRibbonGroup);
            this.adxRibbonTab1.Id = "adxRibbonTab_2bf2dd9d4d6d4922ad1962e45cfd6c3c";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Appointments";
            this.adxRibbonGroup1.Controls.Add(this.adxCreateAppointmentRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.adxAppointmentWithReminderRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.adxRecurringAppointmentRibbonButton);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_aa24473d985847ec923887e4e4b70eec";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxCreateAppointmentRibbonButton
            // 
            this.adxCreateAppointmentRibbonButton.Caption = "Create Appointment";
            this.adxCreateAppointmentRibbonButton.Id = "adxRibbonButton_e38ae0c29a774513b207a5c36d2e068a";
            this.adxCreateAppointmentRibbonButton.Image = 0;
            this.adxCreateAppointmentRibbonButton.ImageList = this.imlIcons32;
            this.adxCreateAppointmentRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCreateAppointmentRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxCreateAppointmentRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxCreateAppointmentRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxCreateAppointmentRibbonButton_OnClick);
            // 
            // imlIcons32
            // 
            this.imlIcons32.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlIcons32.ImageStream")));
            this.imlIcons32.TransparentColor = System.Drawing.Color.Transparent;
            this.imlIcons32.Images.SetKeyName(0, "appointment");
            this.imlIcons32.Images.SetKeyName(1, "reminder");
            this.imlIcons32.Images.SetKeyName(2, "recurring");
            this.imlIcons32.Images.SetKeyName(3, "meeting");
            this.imlIcons32.Images.SetKeyName(4, "dialog");
            this.imlIcons32.Images.SetKeyName(5, "accept");
            // 
            // adxOlFormsManager1
            // 
            this.adxOlFormsManager1.Items.Add(this.adxOlFormsCollectionItem1);
            this.adxOlFormsManager1.SetOwner(this);
            // 
            // adxOlFormsCollectionItem1
            // 
            this.adxOlFormsCollectionItem1.FormClassName = "AppointmentsAndMeetings.AppointmentForm";
            this.adxOlFormsCollectionItem1.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olAppointment;
            this.adxOlFormsCollectionItem1.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.RightSubpane;
            this.adxOlFormsCollectionItem1.UseOfficeThemeForBackground = true;
            // 
            // adxAppointmentWithReminderRibbonButton
            // 
            this.adxAppointmentWithReminderRibbonButton.Caption = "Create Appointment w/ Reminder";
            this.adxAppointmentWithReminderRibbonButton.Id = "adxRibbonButton_bc521dca8aef4497ae807d8516ac92a0";
            this.adxAppointmentWithReminderRibbonButton.Image = 1;
            this.adxAppointmentWithReminderRibbonButton.ImageList = this.imlIcons32;
            this.adxAppointmentWithReminderRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxAppointmentWithReminderRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxAppointmentWithReminderRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxAppointmentWithReminderRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxAppointmentWithReminderRibbonButton_OnClick);
            // 
            // adxRecurringAppointmentRibbonButton
            // 
            this.adxRecurringAppointmentRibbonButton.Caption = "Create Recurring Appointment";
            this.adxRecurringAppointmentRibbonButton.Id = "adxRibbonButton_8c8d84aebdc347518dd22828136867ac";
            this.adxRecurringAppointmentRibbonButton.Image = 2;
            this.adxRecurringAppointmentRibbonButton.ImageList = this.imlIcons32;
            this.adxRecurringAppointmentRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRecurringAppointmentRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxRecurringAppointmentRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxRecurringAppointmentRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxRecurringAppointmentRibbonButton_OnClick);
            // 
            // adxMeetingRibbonGroup
            // 
            this.adxMeetingRibbonGroup.Caption = "Meetings";
            this.adxMeetingRibbonGroup.Controls.Add(this.adxCreateMeetingRibbonButton);
            this.adxMeetingRibbonGroup.Controls.Add(this.adxCheckNamesDialogRibbonButton);
            this.adxMeetingRibbonGroup.Controls.Add(this.adxAcceptMeetingRibbonButton);
            this.adxMeetingRibbonGroup.Id = "adxRibbonGroup_9f1522f7103b429089b7efbe5823ec93";
            this.adxMeetingRibbonGroup.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxMeetingRibbonGroup.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxCreateMeetingRibbonButton
            // 
            this.adxCreateMeetingRibbonButton.Caption = "Create Meeting";
            this.adxCreateMeetingRibbonButton.Id = "adxRibbonButton_e7da3e58c3d743d4a7695142b9e61340";
            this.adxCreateMeetingRibbonButton.Image = 3;
            this.adxCreateMeetingRibbonButton.ImageList = this.imlIcons32;
            this.adxCreateMeetingRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCreateMeetingRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxCreateMeetingRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxCreateMeetingRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxCreateMeetingRibbonButton_OnClick);
            // 
            // adxCheckNamesDialogRibbonButton
            // 
            this.adxCheckNamesDialogRibbonButton.Caption = "Show Check Names Dialog";
            this.adxCheckNamesDialogRibbonButton.Id = "adxRibbonButton_a4e3c5f7bbe540fba4f49e3893706623";
            this.adxCheckNamesDialogRibbonButton.Image = 4;
            this.adxCheckNamesDialogRibbonButton.ImageList = this.imlIcons32;
            this.adxCheckNamesDialogRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCheckNamesDialogRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxCheckNamesDialogRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxCheckNamesDialogRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxCheckNamesDialogRibbonButton_OnClick);
            // 
            // adxAcceptMeetingRibbonButton
            // 
            this.adxAcceptMeetingRibbonButton.Caption = "Accept Selected Meeting";
            this.adxAcceptMeetingRibbonButton.Id = "adxRibbonButton_ce95a951225948e6b78a2ce54fb5b6b5";
            this.adxAcceptMeetingRibbonButton.Image = 5;
            this.adxAcceptMeetingRibbonButton.ImageList = this.imlIcons32;
            this.adxAcceptMeetingRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxAcceptMeetingRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxAcceptMeetingRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxAcceptMeetingRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxAcceptMeetingRibbonButton_OnClick);
            // 
            // AddinModule
            // 
            this.AddinName = "AppointmentsAndMeetings";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void adxCreateAppointmentRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.AppointmentItem appointment = null;
            try
            {
                appointment = (Outlook.AppointmentItem)OutlookApp.CreateItem(Outlook.OlItemType.olAppointmentItem);
                appointment.Start = new DateTime(2015, 01, 25, 13, 30, 00);
                appointment.Duration = 120;
                appointment.Subject = "Drink Coffee";
                appointment.Location = "Bob's Donut Shop";
                appointment.Body = "Go have some coffee and a donut at Bob's";
                appointment.BusyStatus = Outlook.OlBusyStatus.olOutOfOffice;
                appointment.Save();
            }
            finally
            {
                if (appointment != null) Marshal.ReleaseComObject(appointment);
            }
        }

        private void adxAppointmentWithReminderRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.AppointmentItem appointment = null;
            try
            {
                appointment = (Outlook.AppointmentItem)OutlookApp.CreateItem(Outlook.OlItemType.olAppointmentItem);
                appointment.Start = new DateTime(2015, 01, 20, 10, 00, 00);
                appointment.End = new DateTime(2015, 01, 20, 11, 00, 00);
                appointment.ReminderSet = true;
                appointment.ReminderMinutesBeforeStart = 30;
                appointment.Subject = "Dentist Visit";
                appointment.Location = "Medical Building, 123 West Street";
                appointment.Save();
            }
            finally
            {
                if (appointment != null) Marshal.ReleaseComObject(appointment);
            }
        }

        private void adxRecurringAppointmentRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.AppointmentItem appointment = null;
            Outlook.RecurrencePattern recurrencePattern = null;
            try
            {
                appointment = (Outlook.AppointmentItem)OutlookApp.CreateItem(Outlook.OlItemType.olAppointmentItem);
                recurrencePattern = appointment.GetRecurrencePattern();
                recurrencePattern.RecurrenceType = Outlook.OlRecurrenceType.olRecursWeekly;
                recurrencePattern.DayOfWeekMask = Outlook.OlDaysOfWeek.olTuesday | Outlook.OlDaysOfWeek.olFriday;
                recurrencePattern.PatternStartDate = new DateTime(2015, 01, 13);
                recurrencePattern.PatternEndDate = new DateTime(2015, 03, 20);
                recurrencePattern.StartTime = new DateTime(2015, 01, 13, 8, 0, 0);
                recurrencePattern.EndTime = new DateTime(2015, 03, 20, 8, 0, 0);
                recurrencePattern.Duration = 30;
                appointment.Subject = "Project stand up meeting";
                appointment.Save();
            }
            finally
            {
                if (appointment != null) Marshal.ReleaseComObject(appointment);
                if (recurrencePattern != null) Marshal.ReleaseComObject(recurrencePattern);
            }
        }

        private void adxCreateMeetingRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.AppointmentItem appointment = null;
            Outlook.Recipients recipients = null;
            Outlook.Recipient recipient = null;

            try
            {
                appointment = (Outlook.AppointmentItem)OutlookApp.CreateItem(Outlook.OlItemType.olAppointmentItem);
                appointment.Subject = "A meeting";
                appointment.Start = DateTime.Now.AddHours(1);
                appointment.Duration = 60;
                appointment.MeetingStatus = Outlook.OlMeetingStatus.olMeeting;
                recipients = appointment.Recipients;
                recipient = recipients.Add("Alfred Smith");
                recipient.Type = (int)Outlook.OlMeetingRecipientType.olRequired;
                if (recipient.Resolve())
                    appointment.Send();
            }
            finally
            {
                if (recipient != null) Marshal.ReleaseComObject(recipient);
                if (recipients != null) Marshal.ReleaseComObject(recipients);
                if (appointment != null) Marshal.ReleaseComObject(appointment);
            }
        }

        private void adxCheckNamesDialogRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.NameSpace nameSpace = null;
            Outlook.AppointmentItem appointment = null;
            Outlook.Recipients recipients = null;
            Outlook.Recipient recipient1 = null;
            Outlook.Recipient recipient2 = null;
            Outlook.SelectNamesDialog selectDialog = null;
            Outlook.Recipients selectDialogRecipients = null;

            try
            {
                nameSpace = OutlookApp.Session;
                appointment = (Outlook.AppointmentItem)OutlookApp.CreateItem(Outlook.OlItemType.olAppointmentItem);
                appointment.Subject = "A meeting";
                appointment.Start = DateTime.Now.AddHours(1);
                appointment.Duration = 60;
                appointment.MeetingStatus = Outlook.OlMeetingStatus.olMeeting;
                recipients = appointment.Recipients;

                recipient1 = recipients.Add("Alfred Smith");
                recipient1.Type = (int)Outlook.OlMeetingRecipientType.olRequired;

                recipient2 = recipients.Add("Unknown Contact");
                recipient2.Type = (int)Outlook.OlMeetingRecipientType.olOptional;

                for (int i = 1; i <= recipients.Count; i++)
                {
                    Outlook.Recipient recipient = recipients[i];
                    if (!recipient.Resolve())
                    {
                        selectDialog = nameSpace.GetSelectNamesDialog();
                        selectDialogRecipients = selectDialog.Recipients;

                        recipients.Remove(i);
                        selectDialog.Display();
                        if (selectDialogRecipients.ResolveAll())
                        {

                            recipients.Add(recipient.Name);
                        }
                        else
                        {
                            recipients.Remove(i);
                        }

                    }
                    if (recipient != null) Marshal.ReleaseComObject(recipient);
                }
            }
            finally
            {
                if (selectDialogRecipients != null) Marshal.ReleaseComObject(selectDialogRecipients);
                if (selectDialog != null) Marshal.ReleaseComObject(selectDialog);
                if (recipient2 != null) Marshal.ReleaseComObject(recipient2);
                if (recipient1 != null) Marshal.ReleaseComObject(recipient1);
                if (recipients != null) Marshal.ReleaseComObject(recipients);
                if (appointment != null) Marshal.ReleaseComObject(appointment);
                if (nameSpace != null) Marshal.ReleaseComObject(nameSpace);
            }
        }

        private void adxAcceptMeetingRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Selection selection = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                selection = currExplorer.Selection;

                for (int i = 1; i <= selection.Count; i++)
                {
                    if (selection[i] is Outlook.MeetingItem)
                    {
                        Outlook.MeetingItem meeting = selection[i] as Outlook.MeetingItem;
                        Outlook.AppointmentItem appointment = meeting.GetAssociatedAppointment(true);
                        if (appointment != null)
                        {
                            appointment.Respond(Outlook.OlMeetingResponse.olMeetingAccepted, true);
                            Marshal.ReleaseComObject(appointment);
                        }
                        Marshal.ReleaseComObject(meeting);
                    }
                }

            }
            finally
            {
                if (selection != null) Marshal.ReleaseComObject(selection);
                if (currExplorer != null) Marshal.ReleaseComObject(currExplorer);
            }
        }
    }
}

