using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using AddinExpress.OL;
using Outlook = Microsoft.Office.Interop.Outlook;
  
namespace AppointmentsAndMeetings
{
    public partial class AppointmentForm : AddinExpress.OL.ADXOlForm
    {
        public AppointmentForm()
        {
            InitializeComponent();
        }

        private void AppointmentForm_ADXAfterFormShow()
        {
            Outlook.Application outlookApp = null;
            Outlook.Inspector currInspector = null;
            Outlook.AppointmentItem appointment = null;

            try
            {
                outlookApp = (Outlook.Application) this.OutlookAppObj;
                currInspector = outlookApp.ActiveInspector();
                if (currInspector.CurrentItem is Outlook.AppointmentItem)
                {
                    appointment = currInspector.CurrentItem as Outlook.AppointmentItem;
                    this.propertyGrid1.SelectedObject = appointment;
                }
            }
            finally
            {
                if (appointment != null) Marshal.ReleaseComObject(appointment);
                if (currInspector != null) Marshal.ReleaseComObject(currInspector);
                if (outlookApp != null) Marshal.ReleaseComObject(outlookApp);
            }
        }
    }
}
